unit UnZipWin;

(*                                                                      *)
(* Test window for interface into wizunz16.dll by the info-zip group.   *)
(* DLL can be found at: http://quest.jpl.nasa.gov/Info-ZIP/             *)
(*                                                                      *)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, WizUnzip;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
begin
 Left := 10; Top := 10;
end;

procedure TForm1.Button1Click(Sender: TObject);
   var ZipFn : ARRAY[0..144] OF CHAR;
       _DCL  : PDCL;
       I     : INTEGER;
begin
 IF OpenDialog1.Execute
  THEN BEGIN
        ListBox1.Items.Clear;
        StrPCopy(ZipFn,OpenDialog1.FileName);
        WZInitADCL(_DCL,HInstance,Handle,ListBox1.Handle);
        WITH _DCL^ DO
         BEGIN {setup rest of parameters for unzip to list}
          lpszZipFN := @ZipFn;
          nvFlag := wzl_Short; {short listing}
         END; {with}
        I := WZ_UnZip(_DCL); {run unzip proc}
        WZDestroyDCL(_DCL);
        IF ListBox1.Items.Count > 0
         THEN BEGIN
               Button2.Enabled := TRUE;
               ListBox1.ItemIndex := 0;
              END
        ELSE Button2.Enabled := FALSE;
       END;
end;

procedure TForm1.Button2Click(Sender: TObject);
   var Fil, T1, T2 : STRING;
       I           : INTEGER;
       FF          : ARRAY[0..144] OF CHAR;
       Fils        : PACHAR;
       ZipFn       : ARRAY[0..144] OF CHAR;
       _DCL        : PDCL;
       TT          : THANDLE;
       {my variables}
       ext:string[3];
       before:string[8];
       countlimit:byte;
       F:textfile;

begin
 Fil := ListBox1.Items.Strings[ListBox1.ItemIndex];
                                   {copy text from listbox to string}
 Fil := Copy(Fil,28,Length(Fil));  {truncate to (long) filename}
 T2 := Fil;                        {copy this}
 StrPCopy(FF,T2);                  {make a PChar string}
 FOR I := 1 TO Length(T2) DO
  IF T2[I] = '/' THEN T2[I] := '\'; {swap / for \}
 T1 := ExtractFileName(T2);        {get (long) filename}
 I := MessageDlg('Unzip - '+T1,mtConfirmation,[mbNo,mbYes],0);
 IF I <> mrYes THEN Exit;          {confirm action}

 {my bit}

 countlimit:=50;

 {get extension, and truncate it to 3 chars}
 Ext:='';
 for I:=length(T1) downto 1 do if T1[i]='.' then begin
   countlimit:=i-1; {I can't see a good way of doing this with pos() }
   Ext:=copy(T1,I+1,3);
   break; {finish looping if we have it}
 end;

 {get bit before extension}
 Before:='';
 if countlimit>8 then countlimit:=8;
 for I:=1 to countlimit do begin
   if T1[i] in [' ','.'] then Before:=Before+'_' else Before:=Before+T1[i];
 end;


 T1:=Before+'.'+Ext;

 {end of my bit for now - description written later}

 SaveDialog1.FileName := T1;
 IF SaveDialog1.Execute
  THEN BEGIN {got path}
        {only allocating for single file}
        TT := GlobalAlloc(GHnd,SizeOf(PCHAR));
        Fils := GlobalLock(TT);
        Fils^[0] := @FF;
        StrPCopy(ZipFn,OpenDialog1.FileName);
        WZInitADCL(_DCL,HInstance,Handle,0); {create/initialize struct}
        WITH _DCL^ DO
         BEGIN {setup rest of parameters for unzip}
          WITH lpUMB^ DO
           StrPCopy(szUnzipToDirName,ExtractFilePath(SaveDialog1.FileName));
          spaceToUnderscore:=true;
          ArgC := 1; {set equal to number of files submitting}
          lpszZipFN := @ZipFn;
          FNV := Fils;
         END; {with}
        I := WZ_UnZip(_DCL); {run unzip proc}
        WZDestroyDCL(_DCL);  {release control block}
        GlobalUnlock(TT);    {free file list}
        GlobalFree(TT);
        IF I <> wze_OK
         THEN MessageDlg('Unzip failed - '+WZRetErrorString(I),mtError,[mbOK],0)
        ELSE MessageDlg('Unzip success',mtInformation,[mbOK],0);
       END; {then}

  {
  And now, the bit to add the description.
  This isn't very clever - it just adds the new description to the end of the
  file, so you can end up with duplicates.
  }
  AssignFile(F,ExtractFilePath(SaveDialog1.FileName)+'descript.ion');
  if fileexists(ExtractFilePath(SaveDialog1.FileName)+'descript.ion')
    then begin
    Append(F);
    end else begin
    Rewrite(F);
    end; {go to end if exists, else create}
  WriteLn(F,lowercase(T1)+' '+T2); {basic descript.ion syntax: [8.3 filename][space][description] (AFAIK)}
  CloseFile(F);
  {ta-da! finished!}
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 Close;
end;

end.

